/**
 * @author [Tristan Valcke]{@link https://github.com/Itee}
 * @license [BSD-3-Clause]{@link https://opensource.org/licenses/BSD-3-Clause}
 *
 * @file Todo
 *
 * @example Todo
 *
 */

const TAbstractFileConverter = require( 'itee-database' ).TAbstractFileConverter
const THREE                  = require( 'three-full' )

class JsonToThree extends TAbstractFileConverter {

    constructor () {
        super( TAbstractFileConverter.DumpType.JSON )
    }

    _convert ( data, parameters, onSuccess, onProgress, onError ) {
        super._convert( data, parameters, onSuccess, onProgress, onError )

        try {

            const loader    = new THREE.ObjectLoader()
            const threeData = loader.parse( data )
            onSuccess( threeData )

        } catch ( error ) {

            onError( error )

        }

    }

}

module.exports = JsonToThree
